Program Osszegfokozatok;{KERET}
{
  Feladat:
    Az albbi szerkezet file beolvassa s kilistzsa gy, hogy
    kzben a megfelel "struktravltsokkor" ki kell egszteni
    az n. sszegfokozat rekorddal. Vagyis egy j tanszk indulsakor
    a lezrult tanszk sszegfokozata zrja a tanszki sorokat; egy j
    kar esetben nemcsak az lezrult tanszk, hanem a kar sszegfokozat
    rekordja is generland. Azaz a "zr" rekordok szma vagy 1, vagy
    2, vagy 3.
    Mind a nyit, mind az aktulis strukturhoz tartoz sszegfokozati
    rekord egy lapon kell megjelenjen. (Feltesszk, hogy ez lehetsges.)
  sszegfokozat tartalmazza:
    Az aktulis struktrt azonost mezk rtkeit (de csak azokat)
    s az ebbe a struktrba tartoz elemek szmt v. sszegt ...
    (hogy mit, az feladatfgg).
  Bevezet, "elfeladatok":
    1. Sma, lapozott lista.
    2. A file-t gy kilistzni, hogy az egy tanszken dolgozk
       kifrjenek egy lapra (a tanszk nyitrekorddal egytt).
       Ef: nincs tanszk, ahol tbben dolgoznnak, mint a kpernysorok
           szma-1.
  File-szerkezet:
    1. szint: EGYETEM
      szintkd, nv, rektori hivatal cm, tel.szm
      karok

    2. szint: KAR
      szintkd, nv, dkni hivatal cm, tel.szm
      tanszkek (tanszki egysgek)

    3. szint: TANSZKEK
      szintkd, nv, tanszkcm, tel.szm
      dolgozk

    4. szint: DOLGOZ
      szintkd, nv, lakcm, tel.szm, fizets, ...

    Felttelezs:
      A file strukturlisan helyes, tanszkenknt nem res, de
      az adott listzsi feladatban kikttt szmt nem haladja
      meg.

    Megjegyzs:
      A file csupa azonos tpus elembl ll. Ezrt a struktra-
      nyit elemek kiegszlnek --"tartalom nlkli"-- mezkkel,
      amelyeket fl lehet hasznlni az sszegfokozatok utlagos
      trolsra.
}
  Uses  Newdelay,Crt;

  {$i Randnev.inc}

  Type  TSzint=(Dolgozo,Tanszek,Kar,Egyetem,Ures);
  Const KSzint:Array [TSzint] of String=(' ','T','K','E','');{kiirand}
        szintKodH=1; nevH=28; cimH=26; telH=9; fizuH=6;      {kirshossz}
  Type  TElem=Record
                szintKod:TSzint;
                nev:String[nevH]; cim:String[cimH]; tel:String[telH];
                fiz:LongInt;
        End;
  Type  TFile=File of TElem;
        TMegnyitasMod=(Letrehozas,Olvasas);
  Const LaphOssz=20;

  {$i osszfok.inc --
      ebben tallhatk a lnyeg szemponjbl kevsb fontos
      ltalnos konstansok, vltozk, eljrsok, fggvnyek.
      Pl. Var sor:Byte, ami a kpernyre kiirt sorok szmt tartalmazza
          Procedure ElemKi kir egy elemet a fejlchez igazodva (izlsesen)
          Procedure Lapoz, ami lapot trl, s fejlcet r ki, sor-t nullz
          Procedure BillreVar, ami billenyty-lenyomsra vr
          Procedure Megnyit file-t, megfelelo modon
          Procedure General adatfile-t a fenti szerkezetben
          Procedure Lezar file-t
          Procedure Inic, ami inicalizlja a kirst (~MegnyitLista)
  }

{
   Listz rutinok:
   1. Listaz
      -- egyszer (termszetes) virtlis tpus bevezetsvel
   2. ListazMaskent
      -- (ltalnosthat) virtlis tpus bevezetsvel
      (tban a tanszkenktni listzs fel)
   3. TanszTordListaz
     -- listzs 'tanszk dologozk egytt maradsval' felttellel
}
  Procedure Listaz(Var f:TFile);
  (*
    Virtulis tpusok:
    Input:  TBeLap=TFile
            BeNyit,BeVge?,Beolvas,Bezr
            (A reprezentci egyszersge miatt:)
            * BeNyit=Megnyitas,
            * BeVge?=Eof,
            * Beolvas=Read,
            * Bezr=Lezar
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny)
                  =sor:Egsz
            KiNyit,Kiir,Kizr
            * KiNyit=Lapoz,
            * Kiir=ElemKi,
            * Kizr=BillreVar, ha kell; kpernyt trl
  *)
  {
    Tpus-reprezentcik:
    Var sor:Byte; <-- osszfok.inc
  }
  {
    Tpus-implementcik:
  }
    Procedure Kizar{kperny:TKilap};
    Begin
      If sor>0 then BillreVar;
      ClrScr
    End;
  {
    A megolds:
  }
    Var
      elem:TElem;
  Begin{Listaz}
    Megnyit(f,Olvasas); Lapoz{kperny};
    While not Eof(f) do
    Begin
      Read(f,elem);
      ElemKi({kperny,}elem);
    End;
    Lezar(f); Kizar{kperny}
  End{Listaz};

(* ----------------------------------------------------------------- *)

  Procedure ListazMaskent(Var f:TFile);
  (*
    Virtulis tpusok:
    Input:  TBeLap=Rekord(db:Egsz, sorok:Tmb(1..LapHossz:TElem))
            BeNyit,BeVge?,Beolvas,Bezr
            * BeNyit=Megnyitas+belap-puffer inicializls,
            * BeVge?=Eof,
            * Beolvas=puffernyi olvass,
            * Bezr=Lezar)
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny)
                  =sor:Egsz
            KiNyit,Kiir(belap-puffer!),Kizr
            * KiNyit=Lapoz,
            * Kiir=belap-puffer kirsa
                  + vrakozs
                  + Lapoz
                  + puffer inicializlsa
            * Kizr=ClrScr
  *)
  {
    Tpus-reprezentcik:
  }
    Type TBeLap=Record
                  db:Byte; sorok:Array [1..LapHossz] of TElem;
                End;
    Var   egyTanszek:TBeLap;
         {sor:Byte; <-- osszfok.inc}
  {
    Tpus-implementcik:
  }
    Procedure BeNyit(Var f:TFile);
    Begin
      Megnyit(f,Olvasas);
      egyTanszek.db:=0;
    End;
    Procedure Beolvas(Var f:TFile {;Var egyTanszek:TBeLap});
    Begin
      While Not Eof(f) and (egyTanszek.db<LapHossz) do
      Begin
        Inc(egyTanszek.db);
        Read(f,egyTanszek.sorok[egyTanszek.db]);
      End;
    End;
    Procedure Kiir{Var kperny:TKperny, Var egyTanszek:TBelap};
      Var i:Integer;
    Begin
      For i:=1 to egyTanszek.db do
      Begin
        ElemKi({kperny,}egyTanszek.sorok[i]); {nem hasznlom ki, hogy
                                                 figyeli a sorok szmt}
      End;
      egyTanszek.db:=0;
      BillreVar; Lapoz;
    End;
  {
    A megolds:
  }
  Begin{ListazMaskent}
    Benyit(f); Lapoz{kperny};
    While not Eof(f) do
    Begin
      Beolvas(f{,egyTanszek});
      Kiir{kperny,egyTanszek};
    End;
    Lezar(f); ClrScr
  End{ListazMaskent};

(* ----------------------------------------------------------------- *)

  Procedure TanszTordListaz(Var f:TFile);
  (*
    Virtulis tpusok:
    Input:  bemeneti egysg vagy egy tanszk sszes dolgozja a nyitval
                            vagy valami ms elem
            a bementi eleme hatrt csak elreolvassi technikval
            tudjuk megtallni
            TBeEgyseg=Rekord(db:Egsz,
                             e:TElem [az elreolvasott],
                             sorok:Tmb(1..MaxTszDolg+1:TElem))
            Elfelttel => MaxTszDolg+1<=LapHossz
            BeNyit,BeVge?,Beolvas,Bezr
            * BeNyit=Megnyitas+elreolvass
            * BeVge?=Eof,
            * Beolvas=egysgolvass elreolvasssal,
            * Bezr=Lezar)
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny)
                  =sor:Egsz
            KiNyit,Kiir(belap-puffer!),Kizr
            * KiNyit=Lapoz,
            * Kiir=belap-puffer kirsa+sor-llts, ha mg kifr
                   ha nem fr ki, akkor
                   + vrakozs
                   + Lapoz
                   + puffer inicializlsa
            * Kizr= vrakozs + ClrScr
  *)
  {
    Tpus-reprezentcik:
  }
    Type TBeEgyseg=Record
                     db:Byte;
                     e:TElem;{az elreolvasott}
                     elemek:Array [1..LapHossz] of TElem;
                   End;
    Var  egyTanszek:TBeEgyseg;
         {sor:Byte; <-- osszfok.inc}
  {
    Tpus-implementcik:
  }
    Procedure BeNyit(Var f:TFile);
    Begin
      Megnyit(f,Olvasas);
      egyTanszek.db:=0;
      Read(f,egyTanszek.e);
    End;
    Procedure Beolvas(Var f:TFile {;Var egyTanszek:TBeLap});
    {Ef: NOT Eof(f) AND e=elreolvasott elem}
    Begin
      egyTanszek.db:=1; egyTanszek.elemek[1]:=egyTanszek.e;
      Read(f,egyTanszek.e);
      While Not Eof(f) and (egyTanszek.e.szintKod=Dolgozo) do
      Begin
        Inc(egyTanszek.db); egyTanszek.elemek[egyTanszek.db]:=egyTanszek.e;
        Read(f,egyTanszek.e);
      End;
      {Uf: Eof(f)     => egyTanszek[1..egyTanszek.db]+e=egy egysg AND
           NOT Eof(f) => e=kvetkez nem dolgoz elem}
      If Eof(f) then
      Begin
        Inc(egyTanszek.db); egyTanszek.elemek[egyTanszek.db]:=egyTanszek.e;
      End;
      {Uf: egyTanszek[1..egyTanszek.db]=egy egysg AND
           Eof(f)     => e=res AND
           NOT Eof(f) => e=kvetkez nem dolgoz elem}
    End;
    Procedure Kiir{Var kperny:TKperny, Var egyTanszek:TBelap};
      Var i:Integer;
    Begin
      If sor+egyTanszek.db>LapHossz then
      Begin
        BillreVar; Lapoz;
      End;
      For i:=1 to egyTanszek.db do
      Begin
        ElemKi({kperny,}egyTanszek.elemek[i]); {nem hasznlom ki, hogy
                                                  figyeli a sorok szmt,
                                                  csak, hogy kirja s a
                                                  sor-t nveli}
      End;
      egyTanszek.db:=0;
    End;
    Procedure Kizar{kperny:TKilap};
    Begin
      If sor>0 then BillreVar;
      ClrScr
    End;
  {
    A megolds:
  }
  Begin{TanszTordListaz}
    BeNyit(f); Lapoz;
    While not Eof(f) do
    Begin
      Beolvas(f{,egyTanszek});
      Kiir{kperny,egyTanszek};
    End;
    KiZar;
  End{TanszTordListaz};

(* ----------------------------------------------------------------- *)

  Procedure OsszFokosListaz(Var f:TFile);
  (*
    Virtulis tpusok:
    Input:  bemeneti egysg vagy egy tanszk sszes dolgozja a nyitval
                            vagy valami ms elem
            a bementi eleme hatrt csak elreolvassi technikval
            tudjuk megtallni
            TBeEgyseg=Rekord(db:Egsz,
                             e:TElem [az elreolvasott],
                             elemek:Tmb(1..MaxTszDolg+6:TElem))
            Elfelttel => MaxTszDolg+6=LapHossz
            (a "+6"-hoz:
             legrosszabb esetben 3 nyitrekord +
             legrosszabb esetben 3 sszfok rekord)
            BeNyit,BeVge?,Beolvas,Bezr
            * BeNyit=Megnyitas+belap-puffer inicializls+elreolvass
            * BeVge?=Eof,
            * Beolvas=egysgolvass elreolvasssal,
            * Bezr=Lezar
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny)
                  =sor:Egsz
            KiNyit,Kiir(belap-puffer!),Kizr
            * KiNyit=Lapoz,
            * Kiir=belap-puffer kirsa+sor-llts, ha mg kifr
                   ha nem fr ki, akkor
                   + vrakozs
                   + Lapoz
                   + puffer inicializlsa
            * Kizr= vrakozs + ClrScr
  *)
  Begin{OsszFokosListaz}
    (* ide kell valami *)
  End{OsszFokosListaz};

  Var
    egy:TFile;

Begin
  Inic;

  ClrScr;
  HighVideo; Writeln(Kozepre('File-ltrehozs',80)); NormVideo;
  Megnyit(egy,Letrehozas);
  General(egy);
  Lezar(egy);

  ClrScr;
  HighVideo; Writeln(Kozepre('Sma listzs',80)); NormVideo;
 {Sima listzs:}
  Listaz(egy);
(*
  ClrScr;
  HighVideo; Writeln(Kozepre('Sma listzs -- msknt',80)); NormVideo;
 {Sima listzs, msknt:}
  ListazMaskent(egy);

  ClrScr;
  HighVideo; Writeln(Kozepre('Tanszkre trdelt listzs',80)); NormVideo;
 {TanszkreTrdeltListzs:}
  TanszTordListaz(egy);
*)
  ClrScr;
  HighVideo; Writeln(Kozepre('sszegfokozatos listzs',80)); NormVideo;
 {sszfokos listzs:}
  OsszFokosListaz(egy);
End.
